## scons-doc 3.0.0+repack

=== SConstruct ===
#
# SConstruct file to build scons packages during development.
#
# See the README.rst file for an overview of how SCons is built and tested.

from __future__ import print_function

copyright_years = '2001 - 2017'

# This gets inserted into the man pages to reflect the month of release.
month_year = 'September 2017'

#
# Copyright (c) 2001 - 2017 The SCons Foundation
#
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to
# permit persons to whom the Software is furnished to do so, subject to
# the following conditions:
#
# The above copyright notice and this permission notice shall be included
# in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
# KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
# WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
# LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
# OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
# WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
#

import distutils.util
import fnmatch
import os
import os.path
import re
import stat
import sys
import tempfile
import time

import bootstrap

project = 'scons'
default_version = '3.0.0'
copyright = "Copyright (c) %s The SCons Foundation" % copyright_years

platform = distutils.util.get_platform()

def is_windows():
   if platform.startswith('win'):
      return True
   else:
      return False

SConsignFile()

#
# An internal "whereis" routine to figure out if a given program
# is available on this system.
#
def whereis(file):
    exts = ['']
    if is_windows():
        exts += ['.exe']
    for dir in os.environ['PATH'].split(os.pathsep):
        f = os.path.join(dir, file)
        for ext in exts:
            f_ext = f + ext
            if os.path.isfile(f_ext):
                try:
                    st = os.stat(f_ext)
                except:
                    continue
                if stat.S_IMODE(st[stat.ST_MODE]) & 0o111:
                    return f_ext
    return None

#
# We let the presence or absence of various utilities determine whether
# or not we bother to build certain pieces of things.  This should allow
# people to still do SCons packaging work even if they don't have all
# of the utilities installed (e.g. RPM).
#
dh_builddeb = whereis('dh_builddeb')
fakeroot = whereis('fakeroot')
gzip = whereis('gzip')
rpmbuild = whereis('rpmbuild')
hg = os.path.exists('.hg') and whereis('hg')
unzip = whereis('unzip')
zip = whereis('zip')

#
# Now grab the information that we "build" into the files.
#
date = ARGUMENTS.get('DATE')
if not date:
    date = time.strftime("%Y/%m/%d %H:%M:%S", time.localtime(time.time()))

# Datestring for debian
# Should look like: Mon, 03 Nov 2016 13:37:42 -0700
deb_date = time.strftime("%a, %d %b %Y %H:%M:%S +0000", time.gmtime())


developer = ARGUMENTS.get('DEVELOPER')
if not developer:
    for variable in ['USERNAME', 'LOGNAME', 'USER']:
        developer = os.environ.get(variable)
        if developer:
            break

build_system = ARGUMENTS.get('BUILD_SYSTEM')
if not build_system:
    import socket
    build_system = socket.gethostname().split('.')[0]

version = ARGUMENTS.get('VERSION', '')
if not version:
    version = default_version

hg_status_lines = []

if hg:
    cmd = "%s status --all 2> /dev/null" % hg
    hg_status_lines = os.popen(cmd, "r").readlines()

revision = ARGUMENTS.get('REVISION', '')
def generate_build_id(revision):
    return revision

if not revision and hg:
    hg_heads = os.popen("%s heads 2> /dev/null" % hg, "r").read()
    cs = re.search('changeset:\s+(\S+)', hg_heads)
    if cs:
        revision = cs.group(1)
        b = re.search('branch:\s+(\S+)', hg_heads)
        if b:
            revision = b.group(1) + ':' + revision
        def generate_build_id(revision):
            result = revision
            if [l for l in hg_status_lines if l[0] in 'AMR!']:
                result = result + '[MODIFIED]'
            return result

checkpoint = ARGUMENTS.get('CHECKPOINT', '')
if checkpoint:
    if checkpoint == 'd':
        import time
        checkpoint = time.strftime('%Y%m%d', time.localtime(time.time()))
    elif checkpoint == 'r':
        checkpoint = 'r' + revision
    version = version + '.beta.' + checkpoint

build_id = ARGUMENTS.get('BUILD_ID')
if build_id is None:
    if revision:
        build_id = generate_build_id(revision)
    else:
        build_id = ''

import os.path
import distutils.command

no_winpack_templates = not os.path.exists(os.path.join(os.path.split(distutils.command.__file__)[0],'wininst-9.0.exe'))
skip_win_packages = ARGUMENTS.get('SKIP_WIN_PACKAGES',False) or no_winpack_templates

if sys.version_info[0] > 2:
    # TODO: Resolve this issue. Currently fails when run on windows with
    #   File "/opt/local/Library/Frameworks/Python.framework/Versions/3.6/lib/python3.6/distutils/command/bdist_wininst.py", line 262, in create_exe
    #   cfgdata = cfgdata.encode("mbcs")
    #  LookupError: unknown encoding: mbcs
    print("Temporary PY3: Skipping windows package builds")
    skip_win_packages = True

if skip_win_packages:
    print("Skipping the build of Windows packages...")

python_ver = sys.version[0:3]

#
# Adding some paths to sys.path, this is mainly needed
# for the doc toolchain.
#
addpaths = [os.path.abspath(os.path.join(os.getcwd(), 'bin')),
            os.path.abspath(os.path.join(os.getcwd(), 'QMTest'))]
for a in addpaths:
    if a not in sys.path:
        sys.path.append(a)


# Re-exporting LD_LIBRARY_PATH is necessary if the Python version was
# built with the --enable-shared option.

ENV = { 'PATH' : os.environ['PATH'] }
for key in ['LOGNAME', 'PYTHONPATH', 'LD_LIBRARY_PATH']:
    if key in os.environ:
        ENV[key] = os.environ[key]

build_dir = ARGUMENTS.get('BUILDDIR', 'build')
if not os.path.isabs(build_dir):
    build_dir = os.path.normpath(os.path.join(os.getcwd(), build_dir))

command_line_variables = [
    ("BUILDDIR=",       "The directory in which to build the packages.  " +
                        "The default is the './build' subdirectory."),

    ("BUILD_ID=",       "An identifier for the specific build." +
                        "The default is the Subversion revision number."),

    ("BUILD_SYSTEM=",   "The system on which the packages were built.  " +
                        "The default is whatever hostname is returned " +
                        "by socket.gethostname()."),

    ("CHECKPOINT=",     "The specific checkpoint release being packaged, " +
                        "which will be appended to the VERSION string.  " +
                        "A value of CHECKPOINT=d will generate a string " +
                        "of 'd' plus today's date in the format YYYMMDD.  " +
                        "A value of CHECKPOINT=r will generate a " +
                        "string of 'r' plus the Subversion revision " +
                        "number.  Any other CHECKPOINT= string will be " +
                        "used as is.  There is no default value."),

    ("DATE=",           "The date string representing when the packaging " +
                        "build occurred.  The default is the day and time " +
                        "the SConstruct file was invoked, in the format " +
                        "YYYY/MM/DD HH:MM:SS."),

    ("DEVELOPER=",      "The developer who created the packages.  " +
                        "The default is the first set environment " +
                        "variable from the list $USERNAME, $LOGNAME, $USER."),

    ("REVISION=",       "The revision number of the source being built.  " +
                        "The default is the Subversion revision returned " +
                        "'hg heads', with an appended string of " +
                        "'[MODIFIED]' if there are any changes in the " +
                        "working copy."),

    ("VERSION=",        "The SCons version being packaged.  The default " +
                        "is the hard-coded value '%s' " % default_version +
                        "from this SConstruct file."),

    ("SKIP_WIN_PACKAGES=", "If set, skip building win32 and win64 packages."),
]

Default('.', build_dir)

packaging_flavors = [
    ('deb',             "A .deb package.  (This is currently not supported.)"),

    ('rpm',             "A RedHat Package Manager file."),

    ('tar-gz',          "The normal .tar.gz file for end-user installation."),

    ('src-tar-gz',      "A .tar.gz file containing all the source " +
                        "(including tests and documentation)."),

    ('local-tar-gz',    "A .tar.gz file for dropping into other software " +
                        "for local use."),

    ('zip',             "The normal .zip file for end-user installation."),

    ('src-zip',         "A .zip file containing all the source " +
                        "(including tests and documentation)."),

    ('local-zip',       "A .zip file for dropping into other software " +
                        "for local use."),
]

test_deb_dir          = os.path.join(build_dir, "test-deb")
test_rpm_dir          = os.path.join(build_dir, "test-rpm")
test_tar_gz_dir       = os.path.join(build_dir, "test-tar-gz")
test_src_tar_gz_dir   = os.path.join(build_dir, "test-src-tar-gz")
test_local_tar_gz_dir = os.path.join(build_dir, "test-local-tar-gz")
test_zip_dir          = os.path.join(build_dir, "test-zip")
test_src_zip_dir      = os.path.join(build_dir, "test-src-zip")
test_local_zip_dir    = os.path.join(build_dir, "test-local-zip")

unpack_tar_gz_dir     = os.path.join(build_dir, "unpack-tar-gz")
unpack_zip_dir        = os.path.join(build_dir, "unpack-zip")

if is_windows():
    tar_hflag = ''
    python_project_subinst_dir = os.path.join("Lib", "site-packages", project)
    project_script_subinst_dir = 'Scripts'
else:
    tar_hflag = 'h'
    python_project_subinst_dir = os.path.join("lib", project)
    project_script_subinst_dir = 'bin'



import textwrap

indent_fmt = '  %-26s  '

Help("""\
The following aliases build packages of various types, and unpack the
contents into build/test-$PACKAGE subdirectories, which can be used by the
runtest.py -p option to run tests against what's been actually packaged:

""")

aliases = sorted(packaging_flavors + [('doc', 'The SCons documentation.')])

for alias, help_text in aliases:
    tw = textwrap.TextWrapper(
        width = 78,
        initial_indent = indent_fmt % alias,
        subsequent_indent = indent_fmt % '' + '  ',
    )
    Help(tw.fill(help_text) + '\n')

Help("""
The following command-line variables can be set:

""")

for variable, help_text in command_line_variables:
    tw = textwrap.TextWrapper(
        width = 78,
        initial_indent = indent_fmt % variable,
        subsequent_indent = indent_fmt % '' + '  ',
    )
    Help(tw.fill(help_text) + '\n')



zcat = 'gzip -d -c'

#
# Figure out if we can handle .zip files.
#
zipit = None
unzipit = None
try:
    import zipfile

    def zipit(env, target, source):
        print("Zipping %s:" % str(target[0]))
        def visit(arg, dirname, filenames):
            for filename in filenames:
                path = os.path.join(dirname, filename)
                if os.path.isfile(path):
                    arg.write(path)
        # default ZipFile compression is ZIP_STORED
        zf = zipfile.ZipFile(str(target[0]), 'w', compression=zipfile.ZIP_DEFLATED)
        olddir = os.getcwd()
        os.chdir(env['CD'])
        try:
            for dirname, dirnames, filenames in os.walk(env['PSV']):
                visit(zf, dirname, filenames)
        finally:

=== doc/design/SConstruct ===
#
# SConstruct file for building SCons documentation.
#

#
# Copyright (c) 2001 - 2017 The SCons Foundation
#
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to
# permit persons to whom the Software is furnished to do so, subject to
# the following conditions:
#
# The above copyright notice and this permission notice shall be included
# in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
# KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
# WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
# LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
# OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
# WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

import os

env = Environment(ENV={'PATH' : os.environ['PATH']},
                  tools=['docbook'], 
                  toolpath=['../../src/engine/SCons/Tool'],
                  DOCBOOK_DEFAULT_XSL_HTML='html.xsl',
                  DOCBOOK_DEFAULT_XSL_HTMLCHUNKED='chtml.xsl',
                  DOCBOOK_DEFAULT_XSL_PDF='pdf.xsl')

has_pdf = False
if (env.WhereIs('fop') or 
    env.WhereIs('xep')):
    has_pdf = True

#
# Create document
#
env.DocbookXInclude('design_xi.xml', 'main.xml')
env.DocbookXslt('design.xml', 'design_xi.xml', 
                xsl='../xslt/to_docbook.xslt')
env.DocbookHtmlChunked('index.html','design.xml', base_dir='scons-design/')
if has_pdf:
    env.DocbookPdf('scons-design.pdf','design.xml')

=== doc/developer/SConstruct ===
#
# SConstruct file for building SCons documentation.
#

#
# Copyright (c) 2001 - 2017 The SCons Foundation
#
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to
# permit persons to whom the Software is furnished to do so, subject to
# the following conditions:
#
# The above copyright notice and this permission notice shall be included
# in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
# KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
# WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
# LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
# OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
# WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

import os

env = Environment(ENV={'PATH' : os.environ['PATH']},
                  tools=['docbook'], 
                  toolpath=['../../src/engine/SCons/Tool'])

has_pdf = False
if (env.WhereIs('fop') or 
    env.WhereIs('xep')):
    has_pdf = True

#
# Create document
#
env.DocbookXInclude('developer_xi.xml', 'main.xml')
env.DocbookXslt('developer.xml', 'developer_xi.xml', 
                xsl='../xslt/to_docbook.xslt')
env.DocbookHtml('developer.html','developer.xml')
if has_pdf:
    env.DocbookPdf('developer.pdf','developer.xml')

=== doc/man/SConstruct ===
#
# SConstruct file for building SCons documentation.
#

#
# Copyright (c) 2001 - 2017 The SCons Foundation
#
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to
# permit persons to whom the Software is furnished to do so, subject to
# the following conditions:
#
# The above copyright notice and this permission notice shall be included
# in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
# KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
# WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
# LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
# OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
# WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

import os

env = Environment(ENV={'PATH' : os.environ['PATH']},
                  tools=['docbook','gs','zip'],
                  toolpath=['../../src/engine/SCons/Tool'],
                  DOCBOOK_DEFAULT_XSL_HTML='html.xsl',
                  DOCBOOK_DEFAULT_XSL_PDF='pdf.xsl')

has_pdf = False
if (env.WhereIs('fop') or 
    env.WhereIs('xep')):
    has_pdf = True

# Helper function, combining all the steps for a single target
def createManPages(env, target):
    env.DocbookXInclude('%s_xi.xml' % target, '%s.xml' % target)
    env.DocbookXslt('%s_db.xml' % target, '%s_xi.xml' % target, 
                    xsl='../xslt/to_docbook.xslt')
    env.DocbookHtml('scons-%s.html' % target,'%s_db.xml' % target)
    env.DocbookMan('%s.1' % target, '%s_db.xml' % target)
    if has_pdf:
        env.DocbookPdf('scons-%s.pdf' % target,'%s_db.xml' % target)

#
# Create MAN pages
#
createManPages(env, "scons")
createManPages(env, "sconsign")
createManPages(env, "scons-time")

has_gs = False
if env.WhereIs('gs'):
    has_gs = True

#
# Create the EPUB format
#
if has_gs and has_pdf:
    jpg = env.Gs('OEBPS/cover.jpg','scons-scons.pdf', 
                 GSFLAGS='-dNOPAUSE -dBATCH -sDEVICE=jpeg -dFirstPage=1 -dLastPage=1 -dJPEGQ=100 -r72x72 -q')
    epub = env.DocbookEpub('scons-man.epub', 'scons_db.xml', xsl='epub.xsl')
    env.Depends(epub, jpg)

=== doc/python10/SConstruct ===
#
# SConstruct file for building SCons documentation.
#

#
# Copyright (c) 2001 - 2017 The SCons Foundation
#
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to
# permit persons to whom the Software is furnished to do so, subject to
# the following conditions:
#
# The above copyright notice and this permission notice shall be included
# in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
# KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
# WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
# LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
# OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
# WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

import os

env = Environment(ENV={'PATH' : os.environ['PATH']},
                  tools=['docbook'], 
                  toolpath=['../../src/engine/SCons/Tool'])

has_pdf = False
if (env.WhereIs('fop') or 
    env.WhereIs('xep')):
    has_pdf = True

#
# Create document
#
env.DocbookXInclude('python10_xi.xml', 'main.xml')
env.DocbookXslt('python10.xml', 'python10_xi.xml', 
                xsl='../xslt/to_docbook.xslt')
env.DocbookHtml('python10.html','python10.xml')
if has_pdf:
    env.DocbookPdf('python10.pdf','python10.xml')

=== doc/reference/SConstruct ===
#
# SConstruct file for building SCons documentation.
#

#
# Copyright (c) 2001 - 2017 The SCons Foundation
#
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to
# permit persons to whom the Software is furnished to do so, subject to
# the following conditions:
#
# The above copyright notice and this permission notice shall be included
# in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
# KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
# WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
# LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
# OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
# WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

import os

env = Environment(ENV={'PATH' : os.environ['PATH']},
                  tools=['docbook'], 
                  toolpath=['../../src/engine/SCons/Tool'],
                  DOCBOOK_DEFAULT_XSL_HTML='html.xsl',
                  DOCBOOK_DEFAULT_XSL_HTMLCHUNKED='chtml.xsl',
                  DOCBOOK_DEFAULT_XSL_PDF='pdf.xsl')

has_pdf = False
if (env.WhereIs('fop') or 
    env.WhereIs('xep')):
    has_pdf = True

#
# Create document
#
env.DocbookXInclude('reference_xi.xml', 'main.xml')
env.DocbookXslt('reference.xml', 'reference_xi.xml', 
                xsl='../xslt/to_docbook.xslt')
env.DocbookHtml('index.html','reference.xml')
env.DocbookHtmlChunked('index.html', 'reference.xml', base_dir='scons-reference/')
if has_pdf:
    env.DocbookPdf('scons-reference.pdf','reference.xml')

=== doc/user/SConstruct ===
#
# SConstruct file for building SCons documentation.
#

#
# Copyright (c) 2001 - 2017 The SCons Foundation
#
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to
# permit persons to whom the Software is furnished to do so, subject to
# the following conditions:
#
# The above copyright notice and this permission notice shall be included
# in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
# KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
# WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
# LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
# OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
# WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

import os

env = Environment(ENV={'PATH' : os.environ['PATH']},
                  tools=['docbook','gs','zip'], 
                  toolpath=['../../src/engine/SCons/Tool'],
                  DOCBOOK_DEFAULT_XSL_HTML='html.xsl',
                  DOCBOOK_DEFAULT_XSL_HTMLCHUNKED='chtml.xsl',
                  DOCBOOK_DEFAULT_XSL_PDF='pdf.xsl')

has_pdf = False
if (env.WhereIs('fop') or 
    env.WhereIs('xep')):
    has_pdf = True

#
# UserGuide for SCons
#
env.DocbookXInclude('scons_xi.xml', 'main.xml')
env.DocbookXslt('scons_ex.xml', 'scons_xi.xml', 
                xsl='../xslt/xinclude_examples.xslt')
env.DocbookXInclude('scons_exi.xml', 'scons_ex.xml')
env.DocbookXslt('scons_db.xml', 'scons_exi.xml', 
                xsl='../xslt/to_docbook.xslt')
env.DocbookHtml('index.html','scons_db.xml')
env.DocbookHtmlChunked('index.html', 'scons_db.xml', base_dir='scons-user/')
if has_pdf:
    env.DocbookPdf('scons-user.pdf','scons_db.xml')

has_gs = False
if env.WhereIs('gs'):
    has_gs = True

#
# Create the EPUB format
#
if has_gs and has_pdf:
    jpg = env.Gs('OEBPS/cover.jpg','scons-user.pdf', 
                 GSFLAGS='-dNOPAUSE -dBATCH -sDEVICE=jpeg -dFirstPage=1 -dLastPage=1 -dJPEGQ=100 -r72x72 -q')
    epub = env.DocbookEpub('scons-user.epub', 'scons_db.xml', xsl='epub.xsl')
    env.Depends(epub, jpg)

=== debian/changelog ===
scons-doc (3.0.0+repack-1) unstable; urgency=medium

  * New upstream release.
    - Refresh patches:
      + patches/0001-user_guide.patch.
  * New README.source to explain the branching model used.
  * Declare compliance with Debian Policy 4.1.0. (No changes needed).
  * debian/copyright:
    - Add year 2017.
    - Move the repack without unwanted files from repack.sh into
      copyright Files-Excluded.

 -- Jörg Frings-Fürst <debian@jff-webhosting.net>  Sun, 01 Oct 2017 13:43:25 +0200

=== debian/control ===
Source: scons-doc
Section: doc
Priority: optional
Maintainer: Jörg Frings-Fürst <debian@jff-webhosting.net>
Uploaders: Laszlo Boszormenyi (GCS) <gcs@debian.org>
Build-Depends:
 debhelper (>= 10),
 scons (>= 3.0)
Build-Depends-Indep:
 openjdk-8-jre,
 docbook-utils,
 docbook-xml,
 fop,
 python-libxml2,
 python-libxslt1
Standards-Version: 4.1.0
Homepage: https://www.scons.org/
Vcs-Git: https://anonscm.debian.org/cgit/collab-maint/scons-doc.git
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/scons-doc.git

Package: scons-doc
Architecture: all
Depends: ${misc:Depends}
Suggests: scons (>= 3.0)
Description: Documentation for SCons, a replacement for Make
 SCons is a make replacement providing a range of enhanced features such
 as automated dependency generation and built in compilation cache
 support.  SCons rule sets are Python scripts so as well as the features
 it provides itself SCons allows you to use the full power of Python
 to control compilation.
 .
 This package provides the SCons User's guide.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_clean:
	scons -c
	rm -fr build
	find -name "*.pyc" -delete

override_dh_auto_install:
	scons doc
	rm -fr $(CURDIR)/build/doc/HTML/scons-user

=== debian/watch ===
version=4
opts=dversionmangle=s/\+repack(.*)// \
http://sf.net/scons/scons-src-(\d\S*)\.(?:tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## scons-doc 3.1.0+repack

=== SConstruct ===
#
# SConstruct file to build scons packages during development.
#
# See the README.rst file for an overview of how SCons is built and tested.

from __future__ import print_function

copyright_years = '2001 - 2019'

# This gets inserted into the man pages to reflect the month of release.
month_year = 'July 2019'

#
# Copyright (c) 2001 - 2019 The SCons Foundation
#
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to
# permit persons to whom the Software is furnished to do so, subject to
# the following conditions:
#
# The above copyright notice and this permission notice shall be included
# in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
# KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
# WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
# LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
# OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
# WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
#

import distutils.util
import distutils.command
import fnmatch
import os
import os.path
import re
import stat
import sys
import tempfile
import time
import socket
import textwrap

import bootstrap

project = 'scons'
default_version = '3.1.0'
copyright = "Copyright (c) %s The SCons Foundation" % copyright_years

SConsignFile()

#
# We let the presence or absence of various utilities determine whether
# or not we bother to build certain pieces of things.  This should allow
# people to still do SCons packaging work even if they don't have all
# of the utilities installed
#
gzip = whereis('gzip')
git = os.path.exists('.git') and whereis('git')
unzip = whereis('unzip')
zip = whereis('zip')

#
# Now grab the information that we "build" into the files.
#
date = ARGUMENTS.get('DATE')
if not date:
    date = time.strftime("%Y-%m-%d %H:%M:%S", time.gmtime(int(os.environ.get('SOURCE_DATE_EPOCH', time.time()))))

developer = ARGUMENTS.get('DEVELOPER')
if not developer:
    for variable in ['USERNAME', 'LOGNAME', 'USER']:
        developer = os.environ.get(variable)
        if developer:
            break
    if os.environ.get('SOURCE_DATE_EPOCH'):
        developer = '_reproducible'

build_system = ARGUMENTS.get('BUILD_SYSTEM')
if not build_system:
    if os.environ.get('SOURCE_DATE_EPOCH'):
        build_system = '_reproducible'
    else:
        build_system = socket.gethostname().split('.')[0]

version = ARGUMENTS.get('VERSION', '')
if not version:
    version = default_version

git_status_lines = []

if git:
    cmd = "%s ls-files 2> /dev/null" % git
    with os.popen(cmd, "r") as p:
        git_status_lines = p.readlines()

revision = ARGUMENTS.get('REVISION', '')
def generate_build_id(revision):
    return revision

if not revision and git:
    with os.popen("%s rev-parse HEAD 2> /dev/null" % git, "r") as p:
        git_hash = p.read().strip()
    def generate_build_id(revision):
        result = git_hash
        if [l for l in git_status_lines if 'modified' in l]:
            result = result + '[MODIFIED]'
        return result
    revision = git_hash

checkpoint = ARGUMENTS.get('CHECKPOINT', '')
if checkpoint:
    if checkpoint == 'd':
        checkpoint = time.strftime('%Y%m%d', time.localtime(time.time()))
    elif checkpoint == 'r':
        checkpoint = 'r' + revision
    version = version + '.beta.' + checkpoint

build_id = ARGUMENTS.get('BUILD_ID')
if build_id is None:
    if revision:
        build_id = generate_build_id(revision)
    else:
        build_id = ''

#
# Adding some paths to sys.path, this is mainly needed
# for the doc toolchain.
#
addpaths = [os.path.abspath(os.path.join(os.getcwd(), 'bin')),
            os.path.abspath(os.path.join(os.getcwd(), 'testing/framework'))]
for a in addpaths:
    if a not in sys.path:
        sys.path.append(a)


# Re-exporting LD_LIBRARY_PATH is necessary if the Python version was
# built with the --enable-shared option.

ENV = { 'PATH' : os.environ['PATH'] }
for key in ['LOGNAME', 'PYTHONPATH', 'LD_LIBRARY_PATH']:
    if key in os.environ:
        ENV[key] = os.environ[key]

build_dir = ARGUMENTS.get('BUILDDIR', 'build')
if not os.path.isabs(build_dir):
    build_dir = os.path.normpath(os.path.join(os.getcwd(), build_dir))

command_line_variables = [
    ("BUILDDIR=",       "The directory in which to build the packages.  " +
                        "The default is the './build' subdirectory."),

    ("BUILD_ID=",       "An identifier for the specific build." +
                        "The default is the Subversion revision number."),

    ("BUILD_SYSTEM=",   "The system on which the packages were built.  " +
                        "The default is whatever hostname is returned " +
                        "by socket.gethostname(). If SOURCE_DATE_EPOCH " +
                        "env var is set, '_reproducible' is the default."),

    ("CHECKPOINT=",     "The specific checkpoint release being packaged, " +
                        "which will be appended to the VERSION string.  " +
                        "A value of CHECKPOINT=d will generate a string " +
                        "of 'd' plus today's date in the format YYYMMDD.  " +
                        "A value of CHECKPOINT=r will generate a " +
                        "string of 'r' plus the Subversion revision " +
                        "number.  Any other CHECKPOINT= string will be " +
                        "used as is.  There is no default value."),

    ("DATE=",           "The date string representing when the packaging " +
                        "build occurred.  The default is the day and time " +
                        "the SConstruct file was invoked, in the format " +
                        "YYYY/MM/DD HH:MM:SS."),

    ("DEVELOPER=",      "The developer who created the packages.  " +
                        "The default is the first set environment " +
                        "variable from the list $USERNAME, $LOGNAME, $USER." +
                        "If the SOURCE_DATE_EPOCH env var is set, " +
                        "'_reproducible' is the default."),

    ("REVISION=",       "The revision number of the source being built.  " +
                        "The default is the git hash returned " +
                        "'git rev-parse HEAD', with an appended string of " +
                        "'[MODIFIED]' if there are any changes in the " +
                        "working copy."),

    ("VERSION=",        "The SCons version being packaged.  The default " +
                        "is the hard-coded value '%s' " % default_version +
                        "from this SConstruct file."),

]

Default('.', build_dir)

packaging_flavors = [
    ('tar-gz',          "The normal .tar.gz file for end-user installation."),
    ('local-tar-gz',    "A .tar.gz file for dropping into other software " +
                        "for local use."),
    ('zip',             "The normal .zip file for end-user installation."),
    ('local-zip',       "A .zip file for dropping into other software " +
                        "for local use."),
    ('src-tar-gz',      "A .tar.gz file containing all the source " +
                        "(including tests and documentation)."),
    ('src-zip',         "A .zip file containing all the source " +
                        "(including tests and documentation)."),
]

test_tar_gz_dir       = os.path.join(build_dir, "test-tar-gz")
test_src_tar_gz_dir   = os.path.join(build_dir, "test-src-tar-gz")
test_local_tar_gz_dir = os.path.join(build_dir, "test-local-tar-gz")
test_zip_dir          = os.path.join(build_dir, "test-zip")
test_src_zip_dir      = os.path.join(build_dir, "test-src-zip")
test_local_zip_dir    = os.path.join(build_dir, "test-local-zip")

unpack_tar_gz_dir     = os.path.join(build_dir, "unpack-tar-gz")
unpack_zip_dir        = os.path.join(build_dir, "unpack-zip")

if is_windows():
    tar_hflag = ''
    python_project_subinst_dir = os.path.join("Lib", "site-packages", project)
    project_script_subinst_dir = 'Scripts'
else:
    tar_hflag = 'h'
    python_project_subinst_dir = os.path.join("lib", project)
    project_script_subinst_dir = 'bin'




indent_fmt = '  %-26s  '

Help("""\
The following aliases build packages of various types, and unpack the
contents into build/test-$PACKAGE subdirectories, which can be used by the
runtest.py -p option to run tests against what's been actually packaged:

""")

aliases = sorted(packaging_flavors + [('doc', 'The SCons documentation.')])

for alias, help_text in aliases:
    tw = textwrap.TextWrapper(
        width = 78,
        initial_indent = indent_fmt % alias,
        subsequent_indent = indent_fmt % '' + '  ',
    )
    Help(tw.fill(help_text) + '\n')

Help("""
The following command-line variables can be set:

""")

for variable, help_text in command_line_variables:
    tw = textwrap.TextWrapper(
        width = 78,
        initial_indent = indent_fmt % variable,
        subsequent_indent = indent_fmt % '' + '  ',
    )
    Help(tw.fill(help_text) + '\n')




revaction = SCons_revision
revbuilder = Builder(action = Action(SCons_revision,
                                     varlist=['COPYRIGHT', 'VERSION']))


# Just make copies, don't symlink them.
SetOption('duplicate', 'copy')

env = Environment(
                   ENV                 = ENV,

                   BUILD               = build_id,
                   BUILDDIR            = build_dir,
                   BUILDSYS            = build_system,
                   COPYRIGHT           = copyright,
                   DATE                = date,
                   DEB_DATE            = deb_date,
                   DEVELOPER           = developer,
                   DISTDIR             = os.path.join(build_dir, 'dist'),
                   MONTH_YEAR          = month_year,
                   REVISION            = revision,
                   VERSION             = version,

                   TAR_HFLAG           = tar_hflag,

                   ZIP                 = zip,
                   ZIPFLAGS            = '-r',
                   UNZIP               = unzip,
                   UNZIPFLAGS          = '-o -d $UNPACK_ZIP_DIR',

                   ZCAT                = zcat,

                   TEST_SRC_TAR_GZ_DIR = test_src_tar_gz_dir,
                   TEST_SRC_ZIP_DIR    = test_src_zip_dir,
                   TEST_TAR_GZ_DIR     = test_tar_gz_dir,
                   TEST_ZIP_DIR        = test_zip_dir,

                   UNPACK_TAR_GZ_DIR   = unpack_tar_gz_dir,
                   UNPACK_ZIP_DIR      = unpack_zip_dir,

                   BUILDERS            = { 'SCons_revision' : revbuilder,
                                           'SOElim' : soelimbuilder },

                   PYTHON              = '"%s"' % sys.executable,
                   PYTHONFLAGS         = '-tt',
                 )

Version_values = [Value(version), Value(build_id)]

#
# Define SCons packages.
#
# In the original, more complicated packaging scheme, we were going
# to have separate packages for:
#
#       python-scons    only the build engine
#       scons-script    only the script
#       scons           the script plus the build engine
#
# We're now only delivering a single "scons" package, but this is still
# "built" as two sub-packages (the build engine and the script), so
# the definitions remain here, even though we're not using them for
# separate packages.
#

from distutils.sysconfig import get_python_lib


python_scons = {
        'pkg'           : 'python-' + project,
        'src_subdir'    : 'engine',

=== debian/changelog ===
scons-doc (3.1.0+repack-1) unstable; urgency=medium

  * New upstream release.
    - Rewrite Files-Excluded.
  * Migrate to debhelper 12:
    - Change debian/compat to 12.
    - Bump minimum debhelper version in debian/control to >= 12.
  * Declare compliance with Debian Policy 4.4.0. (No changes needed).
  * debian/copyright: Add year 2019.

 -- Jörg Frings-Fürst <debian@jff.email>  Tue, 23 Jul 2019 17:04:59 +0200

scons-doc (3.0.0+repack-2) unstable; urgency=medium

  * Switch from openjdk-8-jre to default-jre (Closes: #894355).
  * Migrate to debhelper 11:
    - Change debian/compat to 11.
    - Bump minimum debhelper version in debian/control to >= 11.
  * Declare compliance with Debian Policy 4.1.4 (No changes needed).
  * Change to my new email address:
    - debian/control
    - debian/copyright
  * debian/copyright:
    - Add year 2018 to debian/*.
    - Use secure URI for copyright format.

 -- Jörg Frings-Fürst <debian@jff.email>  Fri, 04 May 2018 21:42:05 +0200

=== debian/control ===
--- 
+++ 
@@ -1,22 +1,22 @@
 Source: scons-doc
 Section: doc
 Priority: optional
-Maintainer: Jörg Frings-Fürst <debian@jff-webhosting.net>
+Maintainer: Jörg Frings-Fürst <debian@jff.email>
 Uploaders: Laszlo Boszormenyi (GCS) <gcs@debian.org>
 Build-Depends:
- debhelper (>= 10),
+ debhelper (>= 12),
  scons (>= 3.0)
 Build-Depends-Indep:
- openjdk-8-jre,
+ default-jre,
  docbook-utils,
  docbook-xml,
  fop,
  python-libxml2,
  python-libxslt1
-Standards-Version: 4.1.0
+Standards-Version: 4.4.0
 Homepage: https://www.scons.org/
-Vcs-Git: https://anonscm.debian.org/cgit/collab-maint/scons-doc.git
-Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/scons-doc.git
+Vcs-Git: https://salsa.debian.org/debian/scons-doc.git
+Vcs-Browser: https://salsa.debian.org/debian/scons-doc
 
 Package: scons-doc
 Architecture: all

=== debian/watch ===
version=4
opts=dversionmangle=s/\+repack(.*)// \
https://sf.net/scons/scons-src-(\d\S*)\.(?:tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## scons-doc 3.1.2+repack

=== SConstruct ===
--- 
+++ 
@@ -8,7 +8,7 @@
 copyright_years = '2001 - 2019'
 
 # This gets inserted into the man pages to reflect the month of release.
-month_year = 'July 2019'
+month_year = 'December 2019'
 
 #
 # Copyright (c) 2001 - 2019 The SCons Foundation
@@ -49,7 +49,7 @@
 import bootstrap
 
 project = 'scons'
-default_version = '3.1.0'
+default_version = '3.1.2'
 copyright = "Copyright (c) %s The SCons Foundation" % copyright_years
 
 SConsignFile()

=== doc/design/SConstruct ===
--- 
+++ 
@@ -3,7 +3,7 @@
 #
 
 #
-# Copyright (c) 2001 - 2017 The SCons Foundation
+# Copyright (c) 2001 - 2019 The SCons Foundation
 #
 # Permission is hereby granted, free of charge, to any person obtaining
 # a copy of this software and associated documentation files (the

=== doc/developer/SConstruct ===
--- 
+++ 
@@ -3,7 +3,7 @@
 #
 
 #
-# Copyright (c) 2001 - 2017 The SCons Foundation
+# Copyright (c) 2001 - 2019 The SCons Foundation
 #
 # Permission is hereby granted, free of charge, to any person obtaining
 # a copy of this software and associated documentation files (the

=== doc/man/SConstruct ===
--- 
+++ 
@@ -3,7 +3,7 @@
 #
 
 #
-# Copyright (c) 2001 - 2017 The SCons Foundation
+# Copyright (c) 2001 - 2019 The SCons Foundation
 #
 # Permission is hereby granted, free of charge, to any person obtaining
 # a copy of this software and associated documentation files (the

=== doc/python10/SConstruct ===
--- 
+++ 
@@ -3,7 +3,7 @@
 #
 
 #
-# Copyright (c) 2001 - 2017 The SCons Foundation
+# Copyright (c) 2001 - 2019 The SCons Foundation
 #
 # Permission is hereby granted, free of charge, to any person obtaining
 # a copy of this software and associated documentation files (the

=== doc/reference/SConstruct ===
--- 
+++ 
@@ -3,7 +3,7 @@
 #
 
 #
-# Copyright (c) 2001 - 2017 The SCons Foundation
+# Copyright (c) 2001 - 2019 The SCons Foundation
 #
 # Permission is hereby granted, free of charge, to any person obtaining
 # a copy of this software and associated documentation files (the

=== doc/user/SConstruct ===
--- 
+++ 
@@ -3,7 +3,7 @@
 #
 
 #
-# Copyright (c) 2001 - 2017 The SCons Foundation
+# Copyright (c) 2001 - 2019 The SCons Foundation
 #
 # Permission is hereby granted, free of charge, to any person obtaining
 # a copy of this software and associated documentation files (the

=== debian/changelog ===
scons-doc (3.1.2+repack-2) unstable; urgency=medium

  * debian/watch: Add repacksuffix.
  * debian/copyright:
    - Add year 2020 to debian/*.
  * Declare compliance with Debian Policy 4.5.0 (No changes needed).
  * upload to unstable (Closes: #943200).

 -- Jörg Frings-Fürst <debian@jff.email>  Fri, 07 Feb 2020 18:48:06 +0100

scons-doc (3.1.2+repack-1) experimental; urgency=medium

  * New upstream release.
  * debian/control:
    - Add Build-Depends-Indep python3-distutils and python3-lxml.
    - Remove from Build-Depends-Indep python-libxml2 and python-libxslt1.
    - Add Rules-Requires-Root: binary-targets.
    - Remove unused Build-Depends-Indep docbook-utils and docbook-xml.
  * Switch to debhelper-compat:
    - debian/control: change to debhelper-compat (=12).
    - remove debian/compat.

 -- Jörg Frings-Fürst <debian@jff.email>  Sun, 29 Dec 2019 11:45:24 +0100

scons-doc (3.1.1+repack-1) unstable; urgency=medium

  * New upstream release.
    - Rewrite Files-Excluded.
  * Migrate to debhelper 12:
    - Change debian/compat to 12.
    - Bump minimum debhelper version in debian/control to >= 12.
  * Declare compliance with Debian Policy 4.4.1 (No changes needed).
  * debian/copyright: Add year 2019.

 -- Jörg Frings-Fürst <debian@jff.email>  Mon, 07 Oct 2019 17:51:56 +0200

=== debian/control ===
--- 
+++ 
@@ -4,16 +4,15 @@
 Maintainer: Jörg Frings-Fürst <debian@jff.email>
 Uploaders: Laszlo Boszormenyi (GCS) <gcs@debian.org>
 Build-Depends:
- debhelper (>= 12),
- scons (>= 3.0)
+ debhelper-compat (= 12),
+ scons (>= 3.1.2)
 Build-Depends-Indep:
  default-jre,
- docbook-utils,
- docbook-xml,
  fop,
- python-libxml2,
- python-libxslt1
-Standards-Version: 4.4.0
+ python3-distutils,
+ python3-lxml
+Standards-Version: 4.5.0
+Rules-Requires-Root: binary-targets
 Homepage: https://www.scons.org/
 Vcs-Git: https://salsa.debian.org/debian/scons-doc.git
 Vcs-Browser: https://salsa.debian.org/debian/scons-doc

=== debian/watch ===
version=4
opts=dversionmangle=s/\+repack(.*)//,repacksuffix=+repack,compression=xz \
https://sf.net/scons/scons-src-(\d\S*)\.(?:tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
